unit zobrazeniEvidence;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, System.Rtti,
  FMX.StdCtrls, FMX.Controls.Presentation, FMX.Layouts, FMX.Grid,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.Phys.SQLite, FireDAC.Phys.SQLiteDef,
  FireDAC.Stan.ExprFuncs, FireDAC.FMXUI.Wait, FireDAC.Stan.Param, FireDAC.DatS,
  FireDAC.DApt.Intf, FireDAC.DApt, Data.DB, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, FMX.Edit;

type
  TZobrazEvid = class(TForm)
    StringGrid1: TStringGrid;
    Label1: TLabel;
    Button1: TButton;
    StringColumn1: TStringColumn;
    StringColumn2: TStringColumn;
    StringColumn3: TStringColumn;
    StringColumn4: TStringColumn;
    StringColumn5: TStringColumn;
    StringColumn6: TStringColumn;
    StringColumn7: TStringColumn;
    StringColumn8: TStringColumn;
    StringColumn9: TStringColumn;
    StringColumn10: TStringColumn;
    DBConnection: TFDConnection;
    SQLQuery: TFDQuery;
    StringColumn11: TStringColumn;
    Edit1: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public

    curr_DBfile, curr_LHC, curr_rok, curr_oddeleni, curr_dilec, curr_porost,curr_skupina: String;
    procedure zobrazEvidenci(DBfile, LHC, rok, oddeleni, dilec, porost, skupina: String);
  end;

var
  ZobrazEvid: TZobrazEvid;

implementation

uses
  Main, novyZaznamEvid;
{$R *.fmx}
{$R *.XLgXhdpiTb.fmx ANDROID}
{$R *.LgXhdpiTb.fmx ANDROID}
{$R *.LgXhdpiPh.fmx ANDROID}

{ TZobrazEvid }

{ zobrazeni formu pro pridani zaznamu }
procedure TZobrazEvid.Button1Click(Sender: TObject);
begin
novyZaznamEvidence.zobrazNovyZaznam(curr_DBfile, curr_LHC, curr_rok, curr_oddeleni, curr_dilec, curr_porost,curr_skupina);
end;
 { smazani zaznamu }
procedure TZobrazEvid.Button2Click(Sender: TObject);
var
ID,rowIndex,i,j: Integer;
begin
   ID := StrToInt(Edit1.Text);

   SQLQuery.SQL.Clear;
  SQLQuery.SQL.Add
    ('delete from evidence where id=:id');
  SQLQuery.Params.ParamByName('id').Value := ID;
  SQLQuery.ExecSQL;
  SQLQuery.Close;

   SQLQuery.SQL.Clear;
   SQLQuery.SQL.Add
    ('SELECT count(*) as pocetRadku from evidence where odd=:odd AND dil=:dil AND por=:por AND psk=:psk');
    SQLQuery.Params.ParamByName('odd').Value := curr_oddeleni;
    SQLQuery.Params.ParamByName('dil').Value := curr_dilec;
    SQLQuery.Params.ParamByName('por').Value := curr_porost;
    SQLQuery.Params.ParamByName('psk').Value := curr_skupina;
    SQLQuery.OpenOrExecute;

    StringGrid1.RowCount :=  SQLQuery.FieldByName('pocetRadku').AsInteger+10;
    rowIndex := 0;
    SQLQuery.Close;

     for i := 0 to StringGrid1.ColumnCount - 1 do
     for j := 0 to StringGrid1.RowCount - 1 do
  begin
   StringGrid1.Cells[i,j] := '';
  end;

   SQLQuery.SQL.Clear;
   SQLQuery.SQL.Add
    ('SELECT * from evidence where odd=:odd AND dil=:dil AND por=:por AND psk=:psk');
    SQLQuery.Params.ParamByName('odd').Value := curr_oddeleni;
    SQLQuery.Params.ParamByName('dil').Value := curr_dilec;
    SQLQuery.Params.ParamByName('por').Value := curr_porost;
    SQLQuery.Params.ParamByName('psk').Value := curr_skupina;
    SQLQuery.OpenOrExecute;


    while NOT SQLQuery.Eof do
    begin
    StringGrid1.Cells[0,rowIndex] := SQLQuery.FieldByName('ID').AsString;
    StringGrid1.Cells[1,rowIndex] := SQLQuery.FieldByName('datum').AsString;
    StringGrid1.Cells[2,rowIndex] := SQLQuery.FieldByName('vykon').AsString;
    StringGrid1.Cells[3,rowIndex] := SQLQuery.FieldByName('podvykon').AsString;
    StringGrid1.Cells[4,rowIndex] := SQLQuery.FieldByName('druh_vykonu').AsString;
    StringGrid1.Cells[5,rowIndex] := SQLQuery.FieldByName('druh_pohybu').AsString;
    StringGrid1.Cells[6,rowIndex] := SQLQuery.FieldByName('drevina').AsString;
    StringGrid1.Cells[7,rowIndex] := SQLQuery.FieldByName('mzd').AsString;
    StringGrid1.Cells[8,rowIndex] := SQLQuery.FieldByName('plocha').AsString;
    StringGrid1.Cells[9,rowIndex] := SQLQuery.FieldByName('mnozstvi').AsString;
    StringGrid1.Cells[10,rowIndex] := SQLQuery.FieldByName('poznamka').AsString;


    rowIndex := rowIndex+1;
    SQLQuery.Next;
    end;
    SQLQuery.Close;


end;
 { reset a zobrazeni tabulky }
procedure TZobrazEvid.zobrazEvidenci(DBfile, LHC, rok, oddeleni, dilec, porost,
  skupina: String);
  var
  rowIndex,i,j:Integer;
begin

   curr_DBfile := DBfile;
   curr_LHC := LHC;
   curr_rok := rok;
   curr_oddeleni := oddeleni;
   curr_dilec := dilec;
   curr_porost := porost;
   curr_skupina := skupina;
   Edit1.Text := '';


  DBConnection.Params.Values['Database'] := DBfile;

  SQLQuery.SQL.Clear;
  SQLQuery.SQL.Add
    ('create table if not exists evidence (ID INTEGER PRIMARY KEY ASC,datum CHAR(15),odd CHAR(10),dil CHAR(10),'+
    'por CHAR(10),psk CHAR(10),etaz CHAR(10),vykon CHAR(10),podvykon CHAR(10),druh_vykonu CHAR(20),druh_pohybu CHAR(20),'+
    'drevina CHAR(20),mzd CHAR(20),plocha CHAR(20),mnozstvi CHAR(20),poznamka text,popis text)');
  SQLQuery.ExecSQL;
  SQLQuery.Close;

  Label1.Text := 'LHC ' + LHC + '(' + rok + ') - ' + oddeleni + '/' + dilec +
    '/' + porost + '/' + skupina;

    SQLQuery.SQL.Clear;
   SQLQuery.SQL.Add
    ('SELECT count(*) as pocetRadku from evidence where odd=:odd AND dil=:dil AND por=:por AND psk=:psk');
    SQLQuery.Params.ParamByName('odd').Value := curr_oddeleni;
    SQLQuery.Params.ParamByName('dil').Value := curr_dilec;
    SQLQuery.Params.ParamByName('por').Value := curr_porost;
    SQLQuery.Params.ParamByName('psk').Value := curr_skupina;
    SQLQuery.OpenOrExecute;

    StringGrid1.RowCount :=  SQLQuery.FieldByName('pocetRadku').AsInteger+10;
    rowIndex := 0;
    SQLQuery.Close;

     for i := 0 to StringGrid1.ColumnCount - 1 do
     for j := 0 to StringGrid1.RowCount - 1 do
  begin
   StringGrid1.Cells[i,j] := '';
  end;

   SQLQuery.SQL.Clear;
   SQLQuery.SQL.Add
    ('SELECT * from evidence where odd=:odd AND dil=:dil AND por=:por AND psk=:psk');
    SQLQuery.Params.ParamByName('odd').Value := curr_oddeleni;
    SQLQuery.Params.ParamByName('dil').Value := curr_dilec;
    SQLQuery.Params.ParamByName('por').Value := curr_porost;
    SQLQuery.Params.ParamByName('psk').Value := curr_skupina;
    SQLQuery.OpenOrExecute;


    while NOT SQLQuery.Eof do
    begin
    StringGrid1.Cells[0,rowIndex] := SQLQuery.FieldByName('ID').AsString;
    StringGrid1.Cells[1,rowIndex] := SQLQuery.FieldByName('datum').AsString;
    StringGrid1.Cells[2,rowIndex] := SQLQuery.FieldByName('vykon').AsString;
    StringGrid1.Cells[3,rowIndex] := SQLQuery.FieldByName('podvykon').AsString;
    StringGrid1.Cells[4,rowIndex] := SQLQuery.FieldByName('druh_vykonu').AsString;
    StringGrid1.Cells[5,rowIndex] := SQLQuery.FieldByName('druh_pohybu').AsString;
    StringGrid1.Cells[6,rowIndex] := SQLQuery.FieldByName('drevina').AsString;
    StringGrid1.Cells[7,rowIndex] := SQLQuery.FieldByName('mzd').AsString;
    StringGrid1.Cells[8,rowIndex] := SQLQuery.FieldByName('plocha').AsString;
    StringGrid1.Cells[9,rowIndex] := SQLQuery.FieldByName('mnozstvi').AsString;
    StringGrid1.Cells[10,rowIndex] := SQLQuery.FieldByName('poznamka').AsString;


    rowIndex := rowIndex+1;
    SQLQuery.Next;
    end;
    SQLQuery.Close;

  ZobrazEvid.Show;
end;

end.
